<div class="container-fluid p-py-5 accounts-override">
  <p-table #dt [scrollable]="true" scrollHeight="500px" [value]="accounts" (sortFunction)="customSort($event)"
    [customSort]="true" styleClass="p-datatable-striped" tableStyleClass="table-with-action-buttons">
    <ng-template pTemplate="caption">
      <div class="d-flex justify-content-between align-items-center">
        <div class="d-flex align-items-center flex-grow-1">
          <p-checkbox value="Show closed" inputId="sc" id="sc" [(ngModel)]="showInActiveAccounts" [binary]="true"
            (onChange)="dt.filter(this.showInActiveAccounts ? '' : 'true','isActive','equals');"></p-checkbox>
            <label for="sc" class="mt-2 ml-1">Show inactive</label>
        </div>
        <div class="flex-grow-2 text-center">
          <input type="text" pInputText size="50" placeholder="Search"
            (input)="dt.filter(getEventValue($event), 'name', 'contains')" class="w-auto">
        </div>
        <div class="flex-grow-1"></div>
      </div>
    </ng-template>
    <ng-template pTemplate="header">
      <tr>
        <th pSortableColumn="name" style="width: 25%;" (dblclick)="resetSort()">Name
          <span *ngIf="currentSort!='none'">
            <p-sortIcon field="name"></p-sortIcon>
          </span>
        </th>
        <th style="width: 25%;">Internal hours</th>
        <th style="width: 25%;">External hours</th>
        <th style="width: 25%;">Reporting Closing</th>
        <th *ngIf="hasWritePermission">
          <button pButton icon="fa fa-plus" (click)="onAddAccount()"></button>
        </th>
      </tr>
    </ng-template>
    <ng-template pTemplate="body" let-account>
      <tr>
        <td>{{account.name}}</td>
        <td *ngIf="account.overrideHoursSettings; else inherited">
          {{account.minInternal}} - {{account.maxInternal}}
        </td>
        <td *ngIf="account.overrideHoursSettings; else inherited">
          {{account.minExternal}} - {{account.maxExternal}}
        </td>
        <td *ngIf="account.overrideClosingSettings; else inherited">
          <span *ngIf="supportsClosingType(account.closingType); else mondayType">
            {{ account.closingType }} [{{ account.beforeClosing }}; {{ account.afterClosing }}]
          </span>
          <ng-template #mondayType>
            {{ account.closingType }}
          </ng-template>
        </td>
        <ng-template #inherited>
          <td>
            Inherited
          </td>
        </ng-template>
        <td *ngIf="hasWritePermission">
          <div class="d-flex justify-content-between">
            <button pButton icon="fa fa-pencil" (click)="onEditAccount(account)"></button>
          </div>
        </td>
      </tr>
    </ng-template>
  </p-table>

  <p-dialog [(visible)]="dialogVisible" [responsive]="true" [resizable]="false" showEffect="fade" [modal]="true"
    [style]="{ 'width': '530px' }">
    <form [formGroup]="form" (ngSubmit)="onSaveAccount()">
      <!-- Account Name -->
      <div class="form-group form-row" style="margin-top: 1rem">
        <div class="col-md-3 col-form-label">
          Name
        </div>
        <div class="col-md-9">
          <input formControlName="name" id="name" pInputText [(ngModel)]="editAccount.name" type="text" class="w-100"/>
          <div *ngIf="f['name'].touched && f['name'].invalid" class="text-danger">
            <div *ngIf="f['name'].errors && f['name'].errors['required']">Name is required.</div>
            <div *ngIf="f['name'].errors && f['name'].errors['maxlength']">Name must be less than 100 characters long</div>
            <div *ngIf="f['name'].errors && f['name'].errors['canNotContainWhiteSpaces']">Name can not contain whitespaces</div>
          </div>
        </div>
      </div>
      <!-- Budget owner -->
      <div class="form-group form-row" style="margin-top: 1rem">
        <div class="col-md-3 col-form-label">
          Budget owner
        </div>
        <div class="col-md-9">
          <app-filter-dropdown class="w-100"
            [options]="budgetOwnerSelectItems"
            [(selectedItem)]="editAccount.budgetOwnerId"
            placeholder="Please select a user"
            [resetFilterOnHide]="true"
          ></app-filter-dropdown>
        </div>
      </div>

      <!-- Account Type -->
      <div class="form-group form-row" style="margin-top: 1rem">
        <div class="col-md-3 col-form-label">
          Account Type
        </div>
        <div class="col-md-9">
          <p-dropdown [(ngModel)]="editAccount.accountType" [options]="accountTypes"
                  [style]="{ 'width': '100%' }"
                  [ngModelOptions]="{standalone: true}"></p-dropdown>
        </div>
      </div>


      <div class="form-group form-row">
        <div class="col-12">
          <p-fieldset>
            <p-header>
              <p-checkbox [(ngModel)]="editAccount.overrideHoursSettings" [binary]="true"
                label="Override reporting hours settings" [ngModelOptions]="{standalone: true}"></p-checkbox>
            </p-header>
            <div class="form-group form-row">
              <div class="col-3 text-right col-form-label">
                Internal
              </div>
              <div class="col-6">
                <div style="padding: 0 8px">
                  <div style="margin-bottom: 5px; margin-top: -10px;">
                    {{editAccount.minInternal + ' - ' + editAccount.maxInternal}}
                  </div>
                  <p-slider #internalSlider [ngModel]="[editAccount.minInternal * 2, editAccount.maxInternal * 2]"
                    (ngModelChange)="onInternalHoursChange($event)" [range]="true" [min]="0" [max]="24" [step]="1"
                    [disabled]="!editAccount.overrideHoursSettings" [style]="{'width':'100%' }"
                    [ngModelOptions]="{standalone: true}"></p-slider>
                </div>
              </div>
            </div>
            <div class="form-group form-row">
              <div class="col-3 text-right col-form-label">
                External
              </div>
              <div class="col-6">
                <div style="padding: 0 8px">
                  <div style="margin-bottom: 5px; margin-top: -10px;">
                    {{editAccount.minExternal + ' - ' + editAccount.maxExternal}}
                  </div>
                  <p-slider #externalSlider [ngModel]="[editAccount.minExternal * 2, editAccount.maxExternal * 2]"
                    (ngModelChange)="onExternalHoursChange($event)" [range]="true" [min]="0" [max]="24" [step]="1"
                    [disabled]="!editAccount.overrideHoursSettings" [style]="{'width':'100%' }"
                    [ngModelOptions]="{standalone: true}"></p-slider>
                </div>
              </div>
            </div>
          </p-fieldset>
        </div>
      </div>

      <div class="form-group form-row">
        <div class="col-12">
          <p-fieldset>
            <p-header>
              <p-checkbox [(ngModel)]="editAccount.overrideClosingSettings" [formControl]="f['enableClosingControls']" [binary]="true"
                label="Override reporting closing settings" ></p-checkbox>
            </p-header>
            <div class="form-group form-row">
              <div class="col-3 text-right col-form-label align-self-center">
                Closing type
              </div>
              <div class="col-6">
                <p-dropdown [(ngModel)]="editAccount.closingType" [options]="closingTypes"
                  [disabled]="!editAccount.overrideClosingSettings" [style]="{ 'width': '100%' }"
                  [ngModelOptions]="{standalone: true}"></p-dropdown>
              </div>
            </div>
            <div class="form-group form-row no-margin-bottom" *ngIf="supportsClosingType(editAccount.closingType)">
              <div class="col-3 text-right col-form-label align-self-center">
                Window before
              </div>
              <div class="col-2">
                <p-inputNumber
                  [(ngModel)]="editAccount.beforeClosing"
                  [formControl]="f['beforeClosing']"
                  [disabled]="!editAccount.overrideClosingSettings"
                  [useGrouping]="false"
                  [min]="0"
                  [max]="366"
                ></p-inputNumber>
              </div>
              <div class="col-2 text-right col-form-label align-self-center">
                after
              </div>
              <div class="col-2">
                <p-inputNumber
                  [(ngModel)]="editAccount.afterClosing"
                  [formControl]="f['afterClosing']"
                  [disabled]="!editAccount.overrideClosingSettings"
                  [useGrouping]="false"
                  [min]="0"
                  [max]="366"
                ></p-inputNumber>
              </div>
              <div class="col-2 text-right col-form-label align-self-center">
                (days)
              </div>
            </div>
            <div *ngIf="f['beforeClosing'].touched && (f['beforeClosing'].dirty || f['beforeClosing'].invalid) || f['afterClosing'].invalid && (f['afterClosing'].dirty || f['afterClosing'].touched)"
                 class="text-danger validation-message">
              <small class="p-error" *ngIf="f['beforeClosing'].errors?.required || f['afterClosing'].errors?.required">Days are required. </small>
              <small class="p-error" *ngIf="f['beforeClosing'].errors?.min || f['afterClosing'].errors?.min">Days must be at least 0. </small>
              <small class="p-error" *ngIf="f['beforeClosing'].errors?.max || f['afterClosing'].errors?.max">Days must be less than 366. </small>
            </div>
          </p-fieldset>
        </div>
      </div>

      <div class="form-group form-row">
        <div class="col-12 text-right">
          <button pButton label="Save" [disabled]="form.invalid || !formLoaded || !editAccount.budgetOwnerId" type="submit"></button>
        </div>
      </div>
    </form>
  </p-dialog>

</div>
